# Code for the stochastic (Gillespie's algorithm) simulation
# of the singel NOR model..................Angel Goni-Moreno

import numpy as np
import random as r
import math as m

# Parameters initialization
tmax = 200.0
t = 0.0
K1 = 0.1; K_1 = 20.0; K2 = 0.1; K_2 = 20.0; K3 = 0.1; K_3 = 20.0; K4 = 0.1; K_4 = 20.0; K5 = 100.0; K6 = 100.0; K7 = 150.0; K8 = 0.05; K9 = 0.05; K10 = 0.05; K11 = 500; K12 = 500; K13 = 0.02e-3
K14 = 100; K15 = 0.1; K16 = 20.0; K17 = 150; K18 = 0.05; K19 = 0.07;
A = 500; B = 500; G = 1; G_A = 0; G_B = 0; G_AB = 0; Cre = 0; pmd_i = 5; pmd = 0; X = 0; G2 = 1; G2_X = 0; GFP = 0;

# File to store the numbers to plot
f= open('data.txt', 'w')

# Gillespie's algorithm
while t < tmax:
	a =  [K1*A*G, K_1*G_A,  K2*B*G, K_2*G_B, K3*B*G_A, K_3*G_AB, K4*A*G_B, K_4*G_AB, K5*G_A, K6*G_B, K7*G_AB, K8*Cre, K11, K9*A, K12, K10*B, K13*Cre*pmd_i, K14*pmd_i, K15*X*G2, K16*G2_X, K18*X,  K17*G2_X, K19*GFP]
	a0 = sum(a)
	r1 = r.random()
	tau = -m.log(r1)/a0
	t = t+tau
	r2 = r.random() 
	acumsum = np.cumsum(a)/a0
	chosen_reaction = min([i for i in range(len(a)) if acumsum[i] >= r2])
	if chosen_reaction == 0:
		G_A += 1; G -= 1; A -=1
	elif chosen_reaction == 1:
		G_A -= 1; G += 1
	elif chosen_reaction == 2:
		G_B += 1; G -= 1; B -= 1
	elif chosen_reaction == 3:
		G_B -= 1; G +=1
	elif chosen_reaction == 4:
		G_AB += 1; G_A -= 1; B -= 1
	elif chosen_reaction == 5:
		G_AB -= 1; G_A += 1
	elif chosen_reaction == 6:
		G_AB += 1; G_B -= 1; A -= 1
	elif chosen_reaction == 7:
		G_AB -= 1; G_B += 1
	elif chosen_reaction == 8:
		Cre += 1
	elif chosen_reaction == 9:
		Cre += 1
	elif chosen_reaction == 10:
		Cre += 1
	elif chosen_reaction == 11:
		Cre -= 1
	elif chosen_reaction == 12:
		A += 1
	elif chosen_reaction == 13:
		A -= 1
	elif chosen_reaction == 14:
		B += 1
	elif chosen_reaction == 15:
		B -= 1
	elif chosen_reaction == 16:
		pmd += 1; pmd_i -= 1; Cre -= 1
	elif chosen_reaction == 17:
		X += 1
	elif chosen_reaction == 18:
		G2_X += 1; G2 -= 1; X -= 1
	elif chosen_reaction == 19:
		G2_X -= 1 ; G2 += 1; X += 1
	elif chosen_reaction == 20:
		X -= 1
	elif chosen_reaction == 21:
		GFP += 1
	elif chosen_reaction == 22:
		GFP -= 1
        # Write in the file
	f.write(str(t) + ' ' + str(GFP) + ' ' + str(Cre) + ' ' + str(pmd_i) + '\n')

f.close()



