# Code for the stochastic (Gillespie's algorithm) simulation
# of the  NOR1 cell in the XOR model.......Angel Goni-Moreno

import numpy as np
import random as r
import math as m

# Parameters initialization
tmax = 100.0
t = 0.0
K1 = 0.1; K_1 = 20.0; K2 = 0.1; K_2 = 20.0; K3 = 0.1; K_3 = 20.0; K4 = 0.1; K_4 = 20.0; K5 = 100.0; K6 = 100.0; K7 = 150.0; K8 = 0.05; K9 = 0.05; K10 = 0.05; K11 = 500; K12 = 500;
K20 = 0.05; K21 = 150.0; K22 = 0.1; K_22 = 10.0; K23 = 0.02e-3; K24 = 0.02e-3; K25 = 0.02e-3; K26 = 0.02e-3;
A = 500; B = 500; G = 1; G_A = 0; G_B = 0; G_AB = 0; G3 = 1; G3_X = 0; fimB = 0; fimE = 0; X = 0; pmd_F1 = 5; pmd_F2 = 0

# File to store the numbers to plot
f= open('data.txt', 'w')

# Gillespie's algorithm
while t < tmax:

	a =  [K1*A*G, K_1*G_A, K2*B*G, K_2*G_B, K3*B*G_A, K_3*G_AB, K4*A*G_B, K_4*G_AB, K5*G_A, K6*G_B, K7*G_AB, K8*fimE, K25*fimE*pmd_F1, K26*fimE*pmd_F2, K22*X*G3, K_22*G3_X, K20*X, K21*G3, K8*fimB, K23*fimB*pmd_F1, K24*fimB*pmd_F2, K11, K12, K9*A, K10*B]
	a0 = sum(a)
	r1 = r.random()
	tau = -m.log(r1)/a0
	t = t+tau
	r2 = r.random() 
	acumsum = np.cumsum(a)/a0
	chosen_reaction = min([i for i in range(len(a)) if acumsum[i] >= r2])

	if chosen_reaction == 0:
		A -= 1; G -= 1; G_A += 1;
	elif chosen_reaction == 1:
		G_A -= 1; G += 1;
	elif chosen_reaction == 2:
		G_B += 1; B -= 1; G -= 1;
	elif chosen_reaction == 3:
		G_B -= 1; G += 1;
	elif chosen_reaction == 4:
		G_AB += 1; G_A -= 1; B -= 1;
	elif chosen_reaction == 5:
		G_AB -= 1; G_A += 1
	elif chosen_reaction == 6:
		G_AB += 1; G_B -= 1; A -= 1;
	elif chosen_reaction == 7:
		G_AB -= 1; G_B += 1
	elif chosen_reaction == 8:
		fimE += 1; X += 1
	elif chosen_reaction == 9:
		fimE += 1; X += 1;
	elif chosen_reaction == 10:
		fimE += 1; X += 1
	elif chosen_reaction == 11:
		fimE -= 1; 
	elif chosen_reaction == 12:
		pmd_F2 += 1; pmd_F1 -= 1; fimE -= 1
	elif chosen_reaction == 13:
		fimE -= 1;
	elif chosen_reaction == 14:
		X -= 1; G3_X += 1; G3 -= 1
	elif chosen_reaction == 15:
		X -= 1; G3 += 1; G3_X -= 1
	elif chosen_reaction == 16:
		X -= 1;
	elif chosen_reaction == 17:
		fimB += 1;
	elif chosen_reaction == 18:
		fimB -= 1; 
	elif chosen_reaction == 19:
		fimB -= 1; pmd_F1 -= 1; pmd_F2 += 1
	elif chosen_reaction == 20:
		fimB -= 1; pmd_F1 += 1; pmd_F2 -= 1
	elif chosen_reaction == 21:
		A += 1
	elif chosen_reaction == 22:
		B += 1
	elif chosen_reaction == 23:
		A -= 1
	elif chosen_reaction == 24:
		B -= 1

        # Write in the file
	f.write(str(t) + ' ' + str(pmd_F1) + ' ' + str(pmd_F2) + '\n')

f.close()



